## mupen64plus-rsp-z64 1.99.4

=== projects/unix/Makefile ===
#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
# *   mupen64plus-rsp-z64 - Makefile                                        *
# *   http://bitbucket.org/wahrhaft/mupen64plus-rsp-z64/                    *
# *   Copyright (C) 2010 Jon Ring                                           *
# *   Copyright (C) 2008-2009 Richard Goedeken                              *
# *   Copyright (C) 2007-2008 DarkJeztr Tillin9                             *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
# Makefile for Z64 RSP plugin in Mupen64plus.

# detect operating system
UNAME = $(shell uname -s)
OS := NONE
ifeq ("$(UNAME)","Linux")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","linux")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifneq ("$(filter GNU hurd,$(UNAME))","")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","Darwin")
  OS = OSX
  SO_EXTENSION = dylib
  SHARED = -bundle
endif
ifeq ("$(UNAME)","FreeBSD")
  OS = FREEBSD
  SO_EXTENSION = so
  SHARED = -shared
endif
ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(OS)","NONE")
  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# detect system architecture
HOST_CPU ?= $(shell uname -m)
NO_ASM ?= 1
CPU := NONE
ifneq ("$(filter x86_64 amd64,$(HOST_CPU))","")
  CPU := X86
  ifeq ("$(BITS)", "32")
    ARCH_DETECTED := 64BITS_32
  else
    ARCH_DETECTED := 64BITS
  endif
endif
ifneq ("$(filter pentium i%86,$(HOST_CPU))","")
  CPU := X86
  ARCH_DETECTED := 32BITS
endif
# PPC doesn't work yet
#ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
#  CPU := PPC
#  ARCH_DETECTED := 32BITS
#endif
#ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
#  CPU := PPC
#  ARCH_DETECTED := 64BITS
#endif
ifeq ("$(CPU)","NONE")
  $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# base CFLAGS, LIBS, and LDFLAGS
CFLAGS += -ffast-math -funroll-loops -fexpensive-optimizations -fno-strict-aliasing -fvisibility=hidden -I../../src
CXXFLAGS += -fvisibility-inlines-hidden
LDFLAGS += -ldl

# Since we are building a shared library, we must compile with -fPIC for x86_64 CPUs.
# On 32-bit systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
ifeq ($(ARCH_DETECTED), 64BITS)
  CFLAGS += -fPIC -DPIC
endif
# tweak flags for 32-bit build on 64-bit system
ifeq ($(ARCH_DETECTED), 64BITS_32)
  ifeq ($(OS), FREEBSD)
    $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
  endif
  CFLAGS += -m32
  LDFLAGS += -m32 -m elf_i386
endif

# set special flags per-system
ifeq ($(OS), LINUX)
  # only export api symbols
  LDFLAGS += -Wl,-version-script,$(SRCDIR)/rsp_api_export.ver
  ifeq ($(CPU), X86)
    ifeq ($(ARCH_DETECTED), 64BITS)
      CFLAGS += -pipe -O3 -march=athlon64
    else
      CFLAGS += -pipe -O3 -mmmx -msse -march=i686 -mtune=pentium-m -fomit-frame-pointer
    endif
  endif
endif
ifeq ($(OS), OSX)
  ifeq ($(CPU), X86)
    ifeq ($(ARCH_DETECTED), 64BITS)
      CFLAGS += -pipe -O3 -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
      LDFLAGS += -arch x86_64
    else
      CFLAGS += -pipe -O3 -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
      LDFLAGS += -arch i686
    endif
  endif
endif
ifeq ($(CPU), PPC)
  CFLAGS += -mcpu=powerpc
endif

# set mupen64plus core API header path
ifneq ("$(APIDIR)","")
  CFLAGS += "-I$(APIDIR)"
else
  TRYDIR = ../../../mupen64plus-core/src/api
  ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
    CFLAGS += -I$(TRYDIR)
  else
    TRYDIR = /usr/local/include/mupen64plus
    ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
      CFLAGS += -I$(TRYDIR)
    else
      TRYDIR = /usr/include/mupen64plus
      ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
        CFLAGS += -I$(TRYDIR)
      else
        $(error Mupen64Plus API header files not found! Use makefile parameter APIDIR to force a location.)
      endif
    endif
  endif
endif

# set shell function names
CC      ?= gcc
CXX     ?= g++
INSTALL ?= install
ifeq ($(OS),OSX)
  STRIP	?= strip -x 
else
  STRIP	?= strip -s
endif

# set special flags for given Makefile parameters
ifeq ($(DEBUG),1)
  CFLAGS += -g
  STRIP = true # disable binary strip
endif

# set installation options
ifeq ($(PREFIX),)
  PREFIX := /usr/local
endif
ifeq ($(LIBDIR),)
  LIBDIR := $(PREFIX)/lib/mupen64plus
endif

SRCDIR = ../../src
OBJDIR = _obj

# list of source files to compile
SOURCE = \
	$(SRCDIR)/rsp.cpp \
	$(SRCDIR)/rsp_opinfo.cpp \
	$(SRCDIR)/rsp_recomp.cpp \
	$(SRCDIR)/rsp_dasm.cpp \
	$(SRCDIR)/main_rsp.cpp 

# generate a list of object files build, make a temporary directory for them
OBJECTS := $(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(filter %.c, $(SOURCE)))
OBJECTS += $(patsubst $(SRCDIR)/%.cpp, $(OBJDIR)/%.o, $(filter %.cpp, $(SOURCE)))
OBJDIRS = $(dir $(OBJECTS))
$(shell mkdir -p $(OBJDIRS))

# build targets
TARGET = mupen64plus-rsp-z64.$(SO_EXTENSION)

targets:
	@echo "Mupen64Plus-rsp-z64 makefile. "
	@echo "  Targets:"
	@echo "    all           == Build Mupen64Plus rsp-hle plugin"
	@echo "    clean         == remove object files"
	@echo "    rebuild       == clean and re-build all"
	@echo "    install       == Install Mupen64Plus rsp-hle plugin"
	@echo "    uninstall     == Uninstall Mupen64Plus rsp-hle plugin"
	@echo "  Options:"
	@echo "    BITS=32       == build 32-bit binaries on 64-bit machine"
	@echo "    APIDIR=path   == path to find Mupen64Plus Core headers"
	@echo "  Install Options:"
	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
	@echo "    LIBDIR=path   == path to install plugin libraries (default: PREFIX/lib/mupen64plus)"
	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"
	@echo "  Debugging Options:"
	@echo "    DEBUG=1       == add debugging symbols"
	@echo "    V=1           == show verbose compiler output"

all: $(TARGET)

install: $(TARGET)
	$(INSTALL) -d -v "$(DESTDIR)$(LIBDIR)"
	$(INSTALL) -m 0644 $(TARGET) "$(DESTDIR)$(LIBDIR)"

uninstall:
	rm -f "$(DESTDIR)$(LIBDIR)/$(TARGET)"

clean:
	rm -rf ./_obj/* $(TARGET)
	rmdir ./_obj

rebuild: clean all

# build dependency files
CFLAGS += -MD
-include $(OBJECTS:.o=.d)

CXXFLAGS += $(CFLAGS)

# reduced compile output when running make without V=1
ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	Q_CC  = @echo '    CC  '$@;
	Q_CXX = @echo '    CXX '$@;
	Q_LD  = @echo '    LD  '$@;
endif
endif

# build rules

$(TARGET): $(OBJECTS)
	$(Q_LD)$(CXX) $(SHARED) $^ $(LDFLAGS) -o $@
	$(STRIP) $@

$(OBJDIR)/%.o: $(SRCDIR)/%.c
	$(Q_CC)$(CC) -o $@ $(CFLAGS) -c $<

$(OBJDIR)/%.o: $(SRCDIR)/%.cpp
	$(Q_CXX)$(CXX) -o $@ $(CXXFLAGS) -c $<

=== debian/changelog ===
mupen64plus-rsp-z64 (1.99.4-5) unstable; urgency=low

  * Remove hardening-includes which are now integrated in dpkg-
    buildflags
  * Use debian packaging manual URL as format identifier in
    debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Mon, 31 Oct 2011 12:49:27 +0100

mupen64plus-rsp-z64 (1.99.4-4) unstable; urgency=low

  * Don't mix implicit and explicit rules to prevent FTBFS with make
    3.82
  * debian/patches:
    - Add dma_transfer.patch, Fix DMA transfer parameter decoding
    - Add hle_compat.patch, Added a macro for using HLE RSP video/audio
      emulation
  * Build hle video version of mupen64plus-video-z64 in debian/rules

 -- Sven Eckelmann <sven@narfation.org>  Fri, 09 Sep 2011 10:11:51 +0200

mupen64plus-rsp-z64 (1.99.4-3) unstable; urgency=low

  * Upload to unstable
  * debian/rules:
    - Mark all targets as phony
    - Force PIC using Makefile option
    - Remove unintended optimization flags
  * debian/patches:
    - Remove obsolete default-optimisations.patch
    - Add rewrite_makefile.patch, Rewrite Makefile to fix flags and
      linking

 -- Sven Eckelmann <sven@narfation.org>  Sun, 24 Jul 2011 14:24:08 +0200

mupen64plus-rsp-z64 (1.99.4-2) experimental; urgency=low

  * Upgraded to policy 3.9.2, no changes required
  * Update Vcs-* fields to new anonscm.debian.org URLs in debian/control
  * Add multiarch support

 -- Sven Eckelmann <sven@narfation.org>  Sat, 11 Jun 2011 16:52:54 +0200

mupen64plus-rsp-z64 (1.99.4-1) experimental; urgency=low

  * New Upstream Version
  * Updated my maintainer e-mail address
  * Split source package to match upstreams modular release packages
  * debian/copyright:
    - Update to DEP5 revision 164
    - Update copyright years
  * debian/patches:
    - Rebase default-optimisations.patch against 1.99.4
    - Remove upstream merged patches: as-needed.patch,
      correct_fpr32_mapping.patch, correct_security_printf.patch,
      debian-archs.patch, dejavu-font.patch, destdir.patch,
      dont-install-unneeded.patch, fix-7z-subfolder.patch,
      fix-desktop-file.patch, fix_r0_override.patch, fix_readpng.patch,
      ftbfs-debugger.patch, ftbfs-dynarec.patch, ftbfs-glibc210.patch,
      ftbfs-gvariant-type-conflicts.patch, ftbfs-kfreebsd.patch,
      glide64_hurd.patch, glide64-noasm.patch, gtk-open-filter.patch,
      interpreter_x86_fldcw.patch, jttl_fix_romclosed.patch,
      link_gdk.patch, load_aidacrate.patch, load_vistatus.patch,
      noexecstack.patch, optional_signinfo.patch, osd-pause-crash.patch,
      path_max.patch, pie_support.patch, plugin-searchpath.patch,
      remove-gln64.patch, remove-nondfsg-icons.patch,
      resume_on_start.patch, rice-ati-symbols.patch,
      rice-crash-vendorstring.patch, rice_fog.patch, rice_nodebug.patch,
      rice-screenflickering.patch, rice-texturepack-crash.patch,
      rsp_hle_bigendian.patch, rsp_ucode2_reset.patch,
      static-binutils-libs.patch, system-libbz2.patch,
      system-liblzma.patch, system-libpng.patch, system-zlib.patch,
      version-string.patch, xdg-basedir.patch

 -- Sven Eckelmann <sven@narfation.org>  Sat, 22 Jan 2011 11:05:28 +0100

mupen64plus (1.5+dfsg1-14) experimental; urgency=low

  * Upgraded to policy 3.9.1, no changes required
  * Upgrade debhelper compat to v8
  * debian/rules:
    - set *FLAGS using dpkg-buildflags in debian/rules to work like
      dpkg-buildpackage when called directly
    - Use hardening-includes for CFLAGS and LDFLAGS hardened builds
    - Use externally provided LDFLAGS
    - Disable support for debugger due to missing pic/pie support of
      libopcodes.a
  * debian/patches:
    - Add correct_security_printf.patch, Correct possible printf format
      string vulnerability
    - Add pie_support.patch, Add support for PIE/PIC

 -- Sven Eckelmann <sven@narfation.org>  Thu, 23 Sep 2010 13:52:32 +0200

mupen64plus (1.5+dfsg1-13) unstable; urgency=low

  * debian/patches:
    - Add path_max.patch, Add dummy PATH_MAX on systems without it
      (Closes: #588066)
    - Add optional_signinfo.patch, Only use siginfo subsystem if system
      offers it (Closes: #588066)
    - Add glide64_hurd.patch, Define GNU/Hurd as UNIX system for glide64
      (Closes: #588066)

 -- Sven Eckelmann <sven@narfation.org>  Mon, 12 Jul 2010 23:20:02 +0200

mupen64plus (1.5+dfsg1-12) unstable; urgency=low

  * Use googlecode.debian.net instead of complex own filters for
    debian/watch
  * Upgraded to policy 3.9.0, no changes required
  * Build only on i386/amd64 because upstream doesn't to support more
  * debian/patches:
    - Add link_gdk.patch, Link directly against gdk-2.0 instead
      indirectly through gtk+-2.0

 -- Sven Eckelmann <sven@narfation.org>  Mon, 28 Jun 2010 21:31:48 +0200

mupen64plus (1.5+dfsg1-11) unstable; urgency=low

  * debian/patches:
    - Rename ftbfs-gvariant-type-conflicts.path to
      ftbfs-gvariant-type-conflicts.patch
    - Add rice-ati-symbols.patch, Allow to load rice on systems with
      missing opengl extensions

 -- Sven Eckelmann <sven@narfation.org>  Sun, 23 May 2010 11:55:23 +0200

mupen64plus (1.5+dfsg1-10) unstable; urgency=low

  [ Sven Eckelmann ]
  * debian/patches:
    - Add rsp_ucode2_reset.patch, Reset status of specific ucode2 hacks
      after starting again
    - Add rsp_hle_bigendian.patch, Fix wrong high level emulation of rsp
      on big endian systems
    - Add rice-crash-vendorstring.patch, Don't crash on long OpenGL
      vendor string (Closes: #580480, LP: #575968)

  [ Piotr Ożarowski ]
  * DMUA flag set to yes

 -- Sven Eckelmann <sven@narfation.org>  Thu, 06 May 2010 11:34:46 +0200

mupen64plus (1.5+dfsg1-9) unstable; urgency=low

  * debian/patches:
    - Add ftbfs-gvariant-type-conflicts.path, Fix FTBFS due to glib's
      gvariant.h type definitions (Closes: #577329)
    - Add dont-install-unneeded.patch, Don't install files which aren't
      used by us
  * debian/rules:
    - Enable parallel builds using dh's --parallel


=== debian/control ===
Source: mupen64plus-rsp-z64
Section: games
Priority: optional
Maintainer: Tobias Loose <TobiasLoose@gmx.de>
Uploaders: Sven Eckelmann <sven@narfation.org>
DM-Upload-Allowed: yes
Standards-Version: 3.9.2
Homepage: http://code.google.com/p/mupen64plus/
Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-rsp-z64.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-rsp-z64.git
Build-Depends:
 debhelper (>= 8.1.3),
 dpkg-dev (>= 1.16.0),
 libmupen64plus-dev,

Package: mupen64plus-rsp-z64
Architecture: any-i386 any-amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 mupen64plus-rsp-abi-1,
Provides:
 mupen64plus-rsp,
Description: low-level rsp emulation for mupen64plus
 N64 Reality Signal Processor instruction level emulation for graphics plugins
 supporting preprocessed vertex information. It can emulate even unknown or
 uncommon microcodes, but cannot benefit from faster implementation for the
 host cpu.
 .
 This package also provides mupen64plus-video-z64-hlevideo which can be used
 together with high level video emulation plugins like arachnoid, rice or
 glide64.

Package: mupen64plus-rsp-z64-dbg
Section: debug
Priority: extra
Architecture: any-i386 any-amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 mupen64plus-rsp-z64 (= ${binary:Version}),
Description: low-level rsp emulation for mupen64plus debug symbols package
 N64 Reality Signal Processor instruction level emulation for graphics plugins
 supporting preprocessed vertex information. It can emulate even unknown or
 uncommon microcodes, but cannot benefit from faster implementation for the
 host cpu.
 .
 This package contains the debug files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

LDFLAGS += -Wl,--as-needed

DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS=""

DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing

get-orig-source:
	uscan --verbose --force-download

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS) HLEVIDEO=0
	dh_auto_build -- all $(MAKEOPTIONS) HLEVIDEO=1

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS) HLEVIDEO=0
	dh_auto_install -- $(MAKEOPTIONS) HLEVIDEO=1

override_dh_auto_clean:
	dh_auto_clean -- $(MAKEOPTIONS) HLEVIDEO=0
	dh_auto_clean -- $(MAKEOPTIONS) HLEVIDEO=1

override_dh_strip:
	dh_strip -a --dbg-package="$(DBG_PACKAGE)"

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	get-orig-source override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_auto_clean

## mupen64plus-rsp-z64 1.99.4+31+1374ffc147ad

=== projects/unix/Makefile ===
--- 
+++ 
@@ -50,6 +50,12 @@
   SO_EXTENSION = so
   SHARED = -shared
 endif
+ifeq ("$(UNAME)","OpenBSD")
+  OS = FREEBSD
+  SO_EXTENSION = so
+  SHARED = -shared
+  $(warning OS type "$(UNAME)" not officially supported.')
+endif
 ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
   OS = LINUX
   SO_EXTENSION = so
@@ -67,71 +73,91 @@
   CPU := X86
   ifeq ("$(BITS)", "32")
     ARCH_DETECTED := 64BITS_32
+    PIC ?= 0
   else
     ARCH_DETECTED := 64BITS
+    PIC ?= 1
   endif
 endif
 ifneq ("$(filter pentium i%86,$(HOST_CPU))","")
   CPU := X86
   ARCH_DETECTED := 32BITS
-endif
-# PPC doesn't work yet
-#ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
-#  CPU := PPC
-#  ARCH_DETECTED := 32BITS
-#endif
-#ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
-#  CPU := PPC
-#  ARCH_DETECTED := 64BITS
-#endif
+  PIC ?= 0
+endif
+ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
+  CPU := PPC
+  ARCH_DETECTED := 32BITS
+  BIG_ENDIAN := 1
+  PIC ?= 1
+  $(warning Architecture "$(HOST_CPU)" not officially supported.')
+endif
+ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
+  CPU := PPC
+  ARCH_DETECTED := 64BITS
+  BIG_ENDIAN := 1
+  PIC ?= 1
+  $(warning Architecture "$(HOST_CPU)" not officially supported.')
+endif
 ifeq ("$(CPU)","NONE")
   $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
 endif
 
-# base CFLAGS, LIBS, and LDFLAGS
-CFLAGS += -ffast-math -funroll-loops -fexpensive-optimizations -fno-strict-aliasing -fvisibility=hidden -I../../src
+# base CFLAGS, LDLIBS, and LDFLAGS
+OPTFLAGS ?= -O3
+CFLAGS += $(OPTFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src
 CXXFLAGS += -fvisibility-inlines-hidden
-LDFLAGS += -ldl
-
-# Since we are building a shared library, we must compile with -fPIC for x86_64 CPUs.
-# On 32-bit systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
-ifeq ($(ARCH_DETECTED), 64BITS)
-  CFLAGS += -fPIC -DPIC
-endif
+LDFLAGS += $(SHARED)
+
+# Since we are building a shared library, we must compile with -fPIC on some architectures
+# On 32-bit x86 systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
+ifeq ($(PIC), 1)
+  CFLAGS += -fPIC
+  LDFLAGS += -fPIC
+else
+  CFLAGS += -fno-PIC
+  LDFLAGS += -fno-PIC
+endif
+
+HLE=
+ifeq ($(HLEVIDEO), 1)
+  CFLAGS += -DVIDEO_HLE_ALLOWED
+  HLE = -hlevideo
+endif
+
+ifeq ($(BIG_ENDIAN), 1)
+  CFLAGS += -DM64P_BIG_ENDIAN
+endif
+
 # tweak flags for 32-bit build on 64-bit system
 ifeq ($(ARCH_DETECTED), 64BITS_32)
   ifeq ($(OS), FREEBSD)
     $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
   endif
   CFLAGS += -m32
-  LDFLAGS += -m32 -m elf_i386
+  LDFLAGS += -m32 -Wl,-m,elf_i386
 endif
 
 # set special flags per-system
 ifeq ($(OS), LINUX)
   # only export api symbols
   LDFLAGS += -Wl,-version-script,$(SRCDIR)/rsp_api_export.ver
-  ifeq ($(CPU), X86)
-    ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -O3 -march=athlon64
-    else
-      CFLAGS += -pipe -O3 -mmmx -msse -march=i686 -mtune=pentium-m -fomit-frame-pointer
-    endif
-  endif
+  LDLIBS += -ldl
+endif
+ifeq ($(OS), FREEBSD)
+  LDLIBS += -lc
 endif
 ifeq ($(OS), OSX)
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -O3 -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
+      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
       LDFLAGS += -arch x86_64
+      LDLIBS += -ldl
     else
-      CFLAGS += -pipe -O3 -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
+      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
       LDFLAGS += -arch i686
+      LDLIBS += -ldl
     endif
   endif
-endif
-ifeq ($(CPU), PPC)
-  CFLAGS += -mcpu=powerpc
 endif
 
 # set mupen64plus core API header path
@@ -156,20 +182,31 @@
   endif
 endif
 
-# set shell function names
-CC      ?= gcc
-CXX     ?= g++
-INSTALL ?= install
-ifeq ($(OS),OSX)
-  STRIP	?= strip -x 
-else
-  STRIP	?= strip -s
-endif
+# reduced compile output when running make without V=1
+ifneq ($(findstring $(MAKEFLAGS),s),s)
+ifndef V
+	Q_CC  = @echo '    CC  '$@;
+	Q_CXX = @echo '    CXX '$@;
+	Q_LD  = @echo '    LD  '$@;
+endif
+endif
+
+# set base program pointers and flags
+CC       ?= gcc
+CXX      ?= g++
+RM       ?= rm -f
+INSTALL  ?= install
+MKDIR ?= mkdir -p
+COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
+COMPILE.cc = $(Q_CXX)$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
+LINK.o = $(Q_LD)$(CXX) $(LDFLAGS) $(TARGET_ARCH)
 
 # set special flags for given Makefile parameters
 ifeq ($(DEBUG),1)
   CFLAGS += -g
-  STRIP = true # disable binary strip
+  INSTALL_STRIP_FLAG ?= 
+else
+  INSTALL_STRIP_FLAG ?= -s
 endif
 
 # set installation options
@@ -177,11 +214,14 @@
   PREFIX := /usr/local
 endif
 ifeq ($(LIBDIR),)
-  LIBDIR := $(PREFIX)/lib/mupen64plus
+  LIBDIR := $(PREFIX)/lib
+endif
+ifeq ($(PLUGINDIR),)
+  PLUGINDIR := $(LIBDIR)/mupen64plus
 endif
 
 SRCDIR = ../../src
-OBJDIR = _obj
+OBJDIR = _obj$(HLE)
 
 # list of source files to compile
 SOURCE = \
@@ -195,10 +235,10 @@
 OBJECTS := $(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(filter %.c, $(SOURCE)))
 OBJECTS += $(patsubst $(SRCDIR)/%.cpp, $(OBJDIR)/%.o, $(filter %.cpp, $(SOURCE)))
 OBJDIRS = $(dir $(OBJECTS))
-$(shell mkdir -p $(OBJDIRS))
+$(shell $(MKDIR) $(OBJDIRS))
 
 # build targets
-TARGET = mupen64plus-rsp-z64.$(SO_EXTENSION)
+TARGET = mupen64plus-rsp-z64$(HLE).$(SO_EXTENSION)
 
 targets:
 	@echo "Mupen64Plus-rsp-z64 makefile. "
@@ -211,9 +251,13 @@
 	@echo "  Options:"
 	@echo "    BITS=32       == build 32-bit binaries on 64-bit machine"
 	@echo "    APIDIR=path   == path to find Mupen64Plus Core headers"
+	@echo "    OPTFLAGS=flag == compiler optimization (default: -O3)"
+	@echo "    PIC=(1|0)     == Force enable/disable of position independent code"
+	@echo "    HLEVIDEO=(1|0) == Move task of gfx emulation to a HLE video plugins"
 	@echo "  Install Options:"
 	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
-	@echo "    LIBDIR=path   == path to install plugin libraries (default: PREFIX/lib/mupen64plus)"
+	@echo "    LIBDIR=path   == library prefix (default: PREFIX/lib)"
+	@echo "    PLUGINDIR=path == path to install plugin libraries (default: LIBDIR/mupen64plus)"
 	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"
 	@echo "  Debugging Options:"
 	@echo "    DEBUG=1       == add debugging symbols"
@@ -222,15 +266,14 @@
 all: $(TARGET)
 
 install: $(TARGET)
-	$(INSTALL) -d -v "$(DESTDIR)$(LIBDIR)"
-	$(INSTALL) -m 0644 $(TARGET) "$(DESTDIR)$(LIBDIR)"
+	$(INSTALL) -d "$(DESTDIR)$(PLUGINDIR)"
+	$(INSTALL) -m 0644 $(INSTALL_STRIP_FLAG) $(TARGET) "$(DESTDIR)$(PLUGINDIR)"
 
 uninstall:
-	rm -f "$(DESTDIR)$(LIBDIR)/$(TARGET)"
+	$(RM) "$(DESTDIR)$(PLUGINDIR)/$(TARGET)"
 
 clean:
-	rm -rf ./_obj/* $(TARGET)
-	rmdir ./_obj
+	$(RM) -r ./_obj$(HLE) $(TARGET)
 
 rebuild: clean all
 
@@ -240,23 +283,14 @@
 
 CXXFLAGS += $(CFLAGS)
 
-# reduced compile output when running make without V=1
-ifneq ($(findstring $(MAKEFLAGS),s),s)
-ifndef V
-	Q_CC  = @echo '    CC  '$@;
-	Q_CXX = @echo '    CXX '$@;
-	Q_LD  = @echo '    LD  '$@;
-endif
-endif
-
-# build rules
+# standard build rules
+$(OBJDIR)/%.o: $(SRCDIR)/%.c
+	$(COMPILE.c) -o $@ $<
+
+$(OBJDIR)/%.o: $(SRCDIR)/%.cpp
+	$(COMPILE.cc) -o $@ $<
 
 $(TARGET): $(OBJECTS)
-	$(Q_LD)$(CXX) $(SHARED) $^ $(LDFLAGS) -o $@
-	$(STRIP) $@
-
-$(OBJDIR)/%.o: $(SRCDIR)/%.c
-	$(Q_CC)$(CC) -o $@ $(CFLAGS) -c $<
-
-$(OBJDIR)/%.o: $(SRCDIR)/%.cpp
-	$(Q_CXX)$(CXX) -o $@ $(CXXFLAGS) -c $<
+	$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) -o $@
+
+.PHONY: all clean install uninstall targets

=== debian/changelog ===
mupen64plus-rsp-z64 (1.99.4+31+1374ffc147ad-4) unstable; urgency=low

  * debian/patches:
    - Add gcc_lto.patch, Enable support for link-time optimization

 -- Sven Eckelmann <sven@narfation.org>  Sat, 09 Jun 2012 01:05:33 +0200

mupen64plus-rsp-z64 (1.99.4+31+1374ffc147ad-3) unstable; urgency=low

  [ Simon Ruderich ]
  * Let debhelper set the buildflags implicitly

 -- Sven Eckelmann <sven@narfation.org>  Mon, 28 May 2012 00:20:29 +0200

mupen64plus-rsp-z64 (1.99.4+31+1374ffc147ad-2) unstable; urgency=low

  * Update copyright years in debian/copyright
  * Enable all hardening flags in debian/rules
  * Upgraded to policy 3.9.3, no changes required
  * Upgrade debhelper compat to v9
  * Use buildflags.mk to set security flags in debian/rules

 -- Sven Eckelmann <sven@narfation.org>  Sat, 17 Mar 2012 20:18:36 +0100

mupen64plus-rsp-z64 (1.99.4+31+1374ffc147ad-1) experimental; urgency=low

  * New upstream snapshot from revision 1374ffc147add410b62a30e88f88191c0dfa90c2
  * debian/patches:
    - Remove upstream merged patch dma_transfer.patch and hle_compat.patch

 -- Sven Eckelmann <sven@narfation.org>  Sat, 12 Nov 2011 21:44:39 +0100

mupen64plus-rsp-z64 (1.99.4+26+121aa9960630-1) experimental; urgency=low

  * New upstream snapshot from revision 121aa9960630695e10f903ffb7da37ff34247011
  * Don't mix implicit and explicit rules to prevent FTBFS with make 3.82
  * debian/control:
    - Depend on mupen64plus-*-abi-2
    - Build-Depend on libmupen64plus-dev >= 1.99.4+77+8bb0e6b3ae3a-1
  * debian/patches:
    - Remove upstream merged patch rewrite_makefile.patch
  * Add debian/get-orig-source.sh for snapshots

 -- Sven Eckelmann <sven@narfation.org>  Mon, 29 Aug 2011 17:06:12 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Tobias Loose <TobiasLoose@gmx.de>
 Uploaders: Sven Eckelmann <sven@narfation.org>
 DM-Upload-Allowed: yes
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://code.google.com/p/mupen64plus/
 Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-rsp-z64.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-rsp-z64.git
 Build-Depends:
- debhelper (>= 8.1.3),
- dpkg-dev (>= 1.16.0),
- libmupen64plus-dev,
+ debhelper (>= 9),
+ dpkg-dev (>= 1.16.1.1),
+ libmupen64plus-dev (>= 1.99.5),
 
 Package: mupen64plus-rsp-z64
 Architecture: any-i386 any-amd64
@@ -21,7 +21,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
- mupen64plus-rsp-abi-1,
+ mupen64plus-rsp-abi-2,
 Provides:
  mupen64plus-rsp,
 Description: low-level rsp emulation for mupen64plus

=== debian/rules ===
--- 
+++ 
@@ -1,18 +1,13 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
-export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
-export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
-export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
-export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
+export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
-
-LDFLAGS += -Wl,--as-needed
-
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
-MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS=""
+MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="" LTO=1
 
 DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg
 
@@ -20,7 +15,7 @@
 	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing
 
 get-orig-source:
-	uscan --verbose --force-download
+	$(CURDIR)/debian/get-orig-source.sh
 
 override_dh_auto_build:
 	dh_auto_build -- all $(MAKEOPTIONS) HLEVIDEO=0

## mupen64plus-rsp-z64 1.99.5

=== projects/unix/Makefile ===
--- 
+++ 
@@ -261,6 +261,7 @@
 	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"
 	@echo "  Debugging Options:"
 	@echo "    DEBUG=1       == add debugging symbols"
+	@echo "    LTO=1         == enable experimental build with link-time optimization"
 	@echo "    V=1           == show verbose compiler output"
 
 all: $(TARGET)
@@ -282,6 +283,11 @@
 -include $(OBJECTS:.o=.d)
 
 CXXFLAGS += $(CFLAGS)
+ifeq ($(LTO), 1)
+  CFLAGS += -flto
+  CXXFLAGS += -flto
+  LDFLAGS += -fuse-linker-plugin $(CXXFLAGS)
+endif
 
 # standard build rules
 $(OBJDIR)/%.o: $(SRCDIR)/%.c

=== debian/changelog ===
mupen64plus-rsp-z64 (1.99.5-2) unstable; urgency=low

  * Upload to unstable
  * Remove obsolete DM-Upload-Allowed in debian/control
  * Disable extra debug code in release builds with -DNDEBUG in
    debian/rules

 -- Sven Eckelmann <sven@narfation.org>  Sun, 05 May 2013 14:13:27 +0200

mupen64plus-rsp-z64 (1.99.5-1) experimental; urgency=low

  * New Upstream Version
  * Upgraded to policy 3.9.4, no changes required
  * debian/patches:
    - Remove upstream merged gcc_lto.patch

 -- Sven Eckelmann <sven@narfation.org>  Wed, 10 Oct 2012 21:24:07 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,7 @@
 Priority: optional
 Maintainer: Tobias Loose <TobiasLoose@gmx.de>
 Uploaders: Sven Eckelmann <sven@narfation.org>
-DM-Upload-Allowed: yes
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://code.google.com/p/mupen64plus/
 Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-rsp-z64.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-rsp-z64.git

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
-MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="" LTO=1
+MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG" LTO=1
 
 DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg

=== debian/watch ===
version=3

http://bitbucket.org/wahrhaft/mupen64plus-rsp-z64/downloads/ \
	/wahrhaft/mupen64plus-rsp-z64/downloads/mupen64plus-rsp-z64-src-(.*).tar.gz

## mupen64plus-rsp-z64 2.0.0

=== projects/unix/Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 # Makefile for Z64 RSP plugin in Mupen64plus.
 
 # detect operating system
-UNAME = $(shell uname -s)
+UNAME ?= $(shell uname -s)
 OS := NONE
 ifeq ("$(UNAME)","Linux")
   OS = LINUX
@@ -60,6 +60,12 @@
   OS = LINUX
   SO_EXTENSION = so
   SHARED = -shared
+endif
+ifeq ("$(patsubst MINGW%,MINGW,$(UNAME))","MINGW")
+  OS = MINGW
+  SO_EXTENSION = dll
+  SHARED = -shared
+  PIC = 0
 endif
 ifeq ("$(OS)","NONE")
   $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
@@ -84,7 +90,7 @@
   ARCH_DETECTED := 32BITS
   PIC ?= 0
 endif
-ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
+ifneq ("$(filter ppc macppc socppc powerpc,$(HOST_CPU))","")
   CPU := PPC
   ARCH_DETECTED := 32BITS
   BIG_ENDIAN := 1
@@ -98,13 +104,22 @@
   PIC ?= 1
   $(warning Architecture "$(HOST_CPU)" not officially supported.')
 endif
+ifneq ("$(filter arm%,$(HOST_CPU))","")
+  ifeq ("$(filter arm%b,$(HOST_CPU))","")
+    CPU := ARM
+    ARCH_DETECTED := 32BITS
+    PIC ?= 1
+    $(warning Architecture "$(HOST_CPU)" not officially supported.')
+  endif
+endif
 ifeq ("$(CPU)","NONE")
   $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
 endif
 
 # base CFLAGS, LDLIBS, and LDFLAGS
-OPTFLAGS ?= -O3
-CFLAGS += $(OPTFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src
+OPTFLAGS ?= -O3 -flto
+WARNFLAGS ?= -Wall
+CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src
 CXXFLAGS += -fvisibility-inlines-hidden
 LDFLAGS += $(SHARED)
 
@@ -112,16 +127,13 @@
 # On 32-bit x86 systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
 ifeq ($(PIC), 1)
   CFLAGS += -fPIC
-  LDFLAGS += -fPIC
 else
   CFLAGS += -fno-PIC
-  LDFLAGS += -fno-PIC
-endif
-
-HLE=
+endif
+
 ifeq ($(HLEVIDEO), 1)
   CFLAGS += -DVIDEO_HLE_ALLOWED
-  HLE = -hlevideo
+  POSTFIX = -hlevideo
 endif
 
 ifeq ($(BIG_ENDIAN), 1)
@@ -134,7 +146,7 @@
     $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
   endif
   CFLAGS += -m32
-  LDFLAGS += -m32 -Wl,-m,elf_i386
+  LDFLAGS += -Wl,-m,elf_i386
 endif
 
 # set special flags per-system
@@ -147,14 +159,24 @@
   LDLIBS += -lc
 endif
 ifeq ($(OS), OSX)
+  # Select the proper SDK
+  # Also, SDKs are stored in a different location since XCode 4.3
+  OSX_SDK ?= $(shell sw_vers -productVersion | cut -f1 -f2 -d .)
+  OSX_XCODEMAJ = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f1 -d .)
+  OSX_XCODEMIN = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f2 -d .)
+  OSX_XCODEGE43 = $(shell echo "`expr $(OSX_XCODEMAJ) \>= 4``expr $(OSX_XCODEMIN) \>= 3`")
+  ifeq ($(OSX_XCODEGE43), 11)
+    OSX_SYSROOT := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs
+  else
+    OSX_SYSROOT := /Developer/SDKs
+  endif
+
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
-      LDFLAGS += -arch x86_64
+      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
       LDLIBS += -ldl
     else
-      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
-      LDFLAGS += -arch i686
+      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
       LDLIBS += -ldl
     endif
   endif
@@ -192,14 +214,14 @@
 endif
 
 # set base program pointers and flags
-CC       ?= gcc
-CXX      ?= g++
+CC        = $(CROSS_COMPILE)gcc
+CXX       = $(CROSS_COMPILE)g++
 RM       ?= rm -f
 INSTALL  ?= install
 MKDIR ?= mkdir -p
 COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
 COMPILE.cc = $(Q_CXX)$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
-LINK.o = $(Q_LD)$(CXX) $(LDFLAGS) $(TARGET_ARCH)
+LINK.o = $(Q_LD)$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TARGET_ARCH)
 
 # set special flags for given Makefile parameters
 ifeq ($(DEBUG),1)
@@ -221,7 +243,7 @@
 endif
 
 SRCDIR = ../../src
-OBJDIR = _obj$(HLE)
+OBJDIR = _obj$(POSTFIX)
 
 # list of source files to compile
 SOURCE = \
@@ -238,7 +260,7 @@
 $(shell $(MKDIR) $(OBJDIRS))
 
 # build targets
-TARGET = mupen64plus-rsp-z64$(HLE).$(SO_EXTENSION)
+TARGET = mupen64plus-rsp-z64$(POSTFIX).$(SO_EXTENSION)
 
 targets:
 	@echo "Mupen64Plus-rsp-z64 makefile. "
@@ -251,9 +273,11 @@
 	@echo "  Options:"
 	@echo "    BITS=32       == build 32-bit binaries on 64-bit machine"
 	@echo "    APIDIR=path   == path to find Mupen64Plus Core headers"
-	@echo "    OPTFLAGS=flag == compiler optimization (default: -O3)"
+	@echo "    OPTFLAGS=flag == compiler optimization (default: -O3 -flto)"
+	@echo "    WARNFLAGS=flag == compiler warning levels (default: -Wall)"
 	@echo "    PIC=(1|0)     == Force enable/disable of position independent code"
 	@echo "    HLEVIDEO=(1|0) == Move task of gfx emulation to a HLE video plugins"
+	@echo "    POSTFIX=name  == String added to the name of the the build (default: '')"
 	@echo "  Install Options:"
 	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
 	@echo "    LIBDIR=path   == library prefix (default: PREFIX/lib)"
@@ -261,7 +285,6 @@
 	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"
 	@echo "  Debugging Options:"
 	@echo "    DEBUG=1       == add debugging symbols"
-	@echo "    LTO=1         == enable experimental build with link-time optimization"
 	@echo "    V=1           == show verbose compiler output"
 
 all: $(TARGET)
@@ -274,7 +297,7 @@
 	$(RM) "$(DESTDIR)$(PLUGINDIR)/$(TARGET)"
 
 clean:
-	$(RM) -r ./_obj$(HLE) $(TARGET)
+	$(RM) -r $(OBJDIR) $(TARGET)
 
 rebuild: clean all
 
@@ -283,11 +306,6 @@
 -include $(OBJECTS:.o=.d)
 
 CXXFLAGS += $(CFLAGS)
-ifeq ($(LTO), 1)
-  CFLAGS += -flto
-  CXXFLAGS += -flto
-  LDFLAGS += -fuse-linker-plugin $(CXXFLAGS)
-endif
 
 # standard build rules
 $(OBJDIR)/%.o: $(SRCDIR)/%.c

=== debian/changelog ===
mupen64plus-rsp-z64 (2.0.0-1) unstable; urgency=low

  * New Upstream Version
  * Upload to unstable
  * debian/control:
    - Build-Depend on debhelper 9.20130604 for support of parameters when
      detecting targets in dh_auto_*
  * debian/rules:
    - Work around new debhelper 9.20130624 dh_auto_test behavior which is
      causing a FTBFS by adding an explicit override_dh_auto_test rule
  * debian/watch:
    - Verify new upstream versions using GPG key E05E608A04EF22F7596B

 -- Sven Eckelmann <sven@narfation.org>  Sat, 06 Jul 2013 01:31:35 +0200

mupen64plus-rsp-z64 (1.99.5+15+5b238bb813d9-1) experimental; urgency=low

  * New Upstream Snapshot from 5b238bb813d9fd500b92fecd6a769b55bce977dd
  * Enable link-time optimization in debian/rules similar to upstream

 -- Sven Eckelmann <sven@narfation.org>  Wed, 05 Jun 2013 13:25:50 +0200

mupen64plus-rsp-z64 (1.99.5+12+3ac880a8fb3e-1) experimental; urgency=low

  * New upstream snapshot from revision 3ac880a8fb3eaf177968fd212f9936d61b8c3292
  * Disable extra debug code in release builds with -DNDEBUG in
    debian/rules

 -- Sven Eckelmann <sven@narfation.org>  Fri, 08 Feb 2013 10:15:53 +0100

mupen64plus-rsp-z64 (1.99.5+3+ee940659ff77-1) experimental; urgency=low

  * New upstream snapshot from revision ee940659ff7720886049705ba417f679b94c6155
  * Remove obsolete DM-Upload-Allowed in debian/control

 -- Sven Eckelmann <sven@narfation.org>  Sun, 02 Dec 2012 22:32:33 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-rsp-z64.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-rsp-z64.git
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 9.20130604),
  dpkg-dev (>= 1.16.1.1),
  libmupen64plus-dev (>= 1.99.5),

=== debian/rules ===
--- 
+++ 
@@ -2,12 +2,13 @@
 # -*- makefile -*-
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
+export DEB_CFLAGS_MAINT_APPEND=-flto
 export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
-MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG" LTO=1
+MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG"
 
 DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg
 
@@ -16,6 +17,9 @@
 
 get-orig-source:
 	$(CURDIR)/debian/get-orig-source.sh
+
+override_dh_auto_test:
+	# otherwise dh_auto_test fails with debhelper 9.20130624
 
 override_dh_auto_build:
 	dh_auto_build -- all $(MAKEOPTIONS) HLEVIDEO=0
@@ -33,4 +37,4 @@
 	dh_strip -a --dbg-package="$(DBG_PACKAGE)"
 
 .PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
-	get-orig-source override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_auto_clean
+	get-orig-source override_dh_auto_test override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_auto_clean

=== debian/watch ===
version=3

opts="pgpsigurlmangle=s/$/.asc/" \
 http://bitbucket.org/wahrhaft/mupen64plus-rsp-z64/downloads/ \
	/wahrhaft/mupen64plus-rsp-z64/downloads/mupen64plus-rsp-z64-src-(.*).tar.gz

## mupen64plus-rsp-z64 2.0.0%2B12%2Bg5a0a580

=== debian/changelog ===
mupen64plus-rsp-z64 (2.0.0+12+g5a0a580-3) unstable; urgency=medium

  * debian/control, debian/rules:
     - Drop mupen64plus-rsp-z64-dbg in favor of -dbgsym package
  * Update copyright years in debian/copyright
  * Override the lintian warning about missing upstream changelog

 -- Sven Eckelmann <sven@narfation.org>  Fri, 01 Jan 2016 12:57:16 +0100

mupen64plus-rsp-z64 (2.0.0+12+g5a0a580-2) unstable; urgency=medium

  * debian/control:
    - Move Vcs URLs from collab-maint to pkg-games
    - Update upstream URLs
    - Set Maintainer to Debian Games Team

 -- Sven Eckelmann <sven@narfation.org>  Thu, 26 Nov 2015 07:51:32 +0100

mupen64plus-rsp-z64 (2.0.0+12+g5a0a580-1) unstable; urgency=medium

  * New Upstream Snapshot from 5a0a58071ab9073bcca038a32d38b5c323b0883f
  * Upload to unstable
  * debian/control:
    - Upgraded to policy 3.9.6, no changes required
    - Change Vcs-Browser to new alioth CGit URL
  * debian/copyright:
    - Update years in debian/copyright
    - Simplify the the sections

 -- Sven Eckelmann <sven@narfation.org>  Sat, 02 May 2015 13:47:15 +0200

mupen64plus-rsp-z64 (2.0.0+9+g93dc84f-1) experimental; urgency=medium

  * New Upstream Snapshot from 93dc84fd1a7dfb4029f34757fe49027bf167f6ec

 -- Sven Eckelmann <sven@narfation.org>  Fri, 05 Sep 2014 11:24:18 +0200

mupen64plus-rsp-z64 (2.0.0-2) unstable; urgency=low

  * Upgraded to policy 3.9.5, no changes required
  * debian/watch:
    - Change upstream check from bitbucket to github
  * debian/copyright:
    - Change upstream source to github
  * debian/get-orig-source.sh
    - Change upstream repository to github
    - Change SCM from Mercurial to Git
  * Update copyright years in debian/copyright
  * Move keyring for signature verification to new debian/upstream/
  * debian/rules:
    - Use Largefile Support enabled C API

 -- Sven Eckelmann <sven@narfation.org>  Sat, 30 Aug 2014 16:15:37 +0200

=== debian/control ===
Source: mupen64plus-rsp-z64
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sven Eckelmann <sven@narfation.org>,
 Tobias Loose <TobiasLoose@gmx.de>,
Standards-Version: 3.9.6
Homepage: http://mupen64plus.org/
Vcs-Git: git://anonscm.debian.org/pkg-games/mupen64plus-rsp-z64.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/mupen64plus-rsp-z64.git
Build-Depends:
 debhelper (>= 9.20151219),
 dpkg-dev (>= 1.16.1.1),
 libmupen64plus-dev (>= 1.99.5),

Package: mupen64plus-rsp-z64
Architecture: any-i386 any-amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 mupen64plus-rsp-abi-2,
Provides:
 mupen64plus-rsp,
Description: low-level rsp emulation for mupen64plus
 N64 Reality Signal Processor instruction level emulation for graphics plugins
 supporting preprocessed vertex information. It can emulate even unknown or
 uncommon microcodes, but cannot benefit from faster implementation for the
 host cpu.
 .
 This package also provides mupen64plus-video-z64-hlevideo which can be used
 together with high level video emulation plugins like arachnoid, rice or
 glide64.

=== debian/rules ===
--- 
+++ 
@@ -3,14 +3,13 @@
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
 export DEB_CFLAGS_MAINT_APPEND=-flto
+export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
 export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG"
-
-DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg
 
 binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
 	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing
@@ -34,7 +33,7 @@
 	dh_auto_clean -- $(MAKEOPTIONS) HLEVIDEO=1
 
 override_dh_strip:
-	dh_strip -a --dbg-package="$(DBG_PACKAGE)"
+	dh_strip -a --ddeb-migration='mupen64plus-rsp-z64-dbg (<< 2.0.0+12+g5a0a580-3~)'
 
 .PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
 	get-orig-source override_dh_auto_test override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_auto_clean
